require 'json'
nodes = JSON.parse(File.read('Nodes.json'))

# Here starts the configuration: Do not change the 2
Vagrant.configure(2) do |config|

  # Here loops over the cluster list to get diferent machine parameters
  nodes.each_with_index do |(hostname, values), index|

    # HERE IS THE TRICK:
    # Multiple machines shall be initialized this way,
    # not using the generic config.vm
    config.vm.define hostname do |this_vm|
      this_vm.vm.box = "centos/7"
      this_vm.vm.network "private_network", ip: values['interface']['ip']
      this_vm.vm.hostname = hostname

      # Need to put enough memory and cpu!
      this_vm.vm.provider "virtualbox" do |v|
        v.customize ["modifyvm", :id, "--memory", "4096"]

        if nodes[hostname]['role'] == "compute"
          v.cpus = 2
        end
      end

      this_vm.vm.provision :ansible do |ansible|
 		        ansible.playbook= "playbook.yml"
            ansible.vault_password_file='vault_secret.py'
      end
    end
  end
end
